import processing.video.*;
Capture video;

int trackColor;

void setup() {
  size(300, 300);
  video = new Capture(this, width, height, 30);
  trackColor = color(0,255,0);
  stroke(255,0,0);
  noFill();
}

void captureEvent(Capture myCapture) {
  myCapture.read();
}

void draw() {
  int closestX = 0;
  int  closestY = 0;
  float closestDiff = 100000f;            
  image(video,0,0);

  for (int x=0; x<video.width;  x++) {
    for (int y=0; y<video.height; y++){
      color currentColor = video.pixels[x + y*video.width];
      float r1 = red(currentColor);
      float g1 = green(currentColor);
      float b1 = blue(currentColor);

      float r2 = red(trackColor);
      float g2 = green(trackColor);
      float b2 = blue(trackColor);

      float d = dist(r1,g1,b1,r2,g2,b2);
      if (d < closestDiff) {
        closestX = x;
        closestY = y;
        closestDiff = d;            
      }
    }
  }
  ellipse(closestX, closestY, 10,10); 
}

void mousePressed() {
  color currentColor = video.pixels[mouseX + mouseY*video.width];     
  trackColor = currentColor;
}
